'SIDstick Player V1.1 by Jeff Ledger / Oldbitcollector
'2/15/10 - n. mcclanahan: added video display and NES control for use with El Jugador

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000    

nxxt = 4
prev = 5
play = 6
vol  = 0
lat =   24
data = 25
clk =  23

VAR
  byte buffer[25]
  byte filename[18]
  byte fileNumber
  long waitTime
    
OBJ
  SID : "SIDCog"
  SD  : "fsrw"
  nes: "NES"
  term    : "tv_terminal"
 
PUB Main  | volume, counter, time
  term.start(12)   
  SID.start(10,11) 
  NES.Init(lat, data, clk)                                                 
  sd.mount(0)      
  fileNumber := 0
  volume:=1
  counter:=0

   
 'Main loop
  repeat
    if( sd.pread(@buffer, 25) ) < 0
       fileNumber++
       openNextFile
  
    if NES.BtnPressed(NES#RIGHT)
      filenumber++
      bytefill(@buffer,0,25)
      SID.updateRegisters(@buffer)
      waitcnt(clkfreq/2 + cnt)
      openNextFile
      
    if NES.BtnPressed(NES#LEFT)
      filenumber--
      if filenumber < 0
         filenumber := 0
      bytefill(@buffer,0,25)
      SID.updateRegisters(@buffer)
      waitcnt(clkfreq/2 + cnt)
      openNextFile

    if NES.BtnPressed(NES#START)  and counter > 20
      bytefill(@buffer,0,25)
      SID.updateRegisters(@buffer)
      waitcnt(clkfreq/2 + cnt)
      counter:=0
      repeat until NES.BtnPressed(NES#START)

    'Wait 1/50 sec between updates (PAL VBL) 
    repeat until cnt-waitTime>0
    waitTime := cnt + 80_000_000/50
    
    'Calculate Volume from RCdelay
    volume := 15

    'Update SID registers 
    buffer[24]:=(buffer[24]&$F0) | (volume&$0F)
    counter++
    SID.updateRegisters( @buffer )

PUB openNextFile | i,x
    sd.opendir
    repeat i from 0 to fileNumber
        sd.nextfile( @filename )

    repeat x from 0 to 8
      if filename[x]=="."
        if filename[x+1]=="D" and filename[x+2]=="M" and filename[x+3]=="P"
          showsong(@filename)
          sd.popen( @filename, "r")
          waitTime := cnt + 10_000_000

        ELSE   
          skipbadfile

PUB skipbadfile
fileNumber++
openNextFile

PUB showsong(dispfile)
term.out($00)
term.str(@title)
term.str(dispfile)
  


DAT
title   byte    "SIDSTICK SOFTWARE PLAYER",13,13,"Check out the Real SIDStick @",13,"www.gadgetgangster.com/236", 13,13,"Now Playing:",0

     